#include "Affichage.h"
#include "Snake.h"


char spi_transfer(volatile char data){
  SPDR = data;                    // Start the transmission
  while (!(SPSR & (1<<SPIF)))     // Wait the end of the transmission
  {
  };
}

void setup_affichage(){
  byte clr;
  pinMode(DATAOUT,OUTPUT);
  pinMode(SPICLOCK,OUTPUT);
  pinMode(CHIPSELECT,OUTPUT);
  digitalWrite(CHIPSELECT,HIGH); //disable device
  SPCR = B01010001;             //SPI Registers
  SPSR = SPSR & B11111110;      //make sure the speed is 125KHz
  clr=SPSR;
  clr=SPDR;
  delay(10);
}


void affichage_envoi_byte(){
  digitalWrite(CHIPSELECT,LOW); // enable the ChipSelect on the backpack
  delayMicroseconds(100);
  for(int i=0; i<NB_OCTETS; i++){
      for(int j=0; j<8; j++){
          spi_transfer((matrix[i] >> j) & 1);
      }
  }
  digitalWrite(CHIPSELECT,HIGH); // disable the ChipSelect on the backpack
}


void clearMatrix_byte() {
    // remise a 0 de la matrice
  for (int i=0; i<NB_OCTETS; i++){
    matrix[i] = 0;
  }
}


int puissance(int a, int b){
  //la fonction puissance de math.h n'est pas fiable
  int c = 1;
  for(int i=0;i<b;i++) c *= a;
  return c;
}


void updateMatrix_byte(){ //stocke dans le tableau matrix les leds allumees par le serpent et la pomme
// dans matrix un bit = une led
 clearMatrix_byte();
 int i = 0;
 while(i<snakesize && i<NB_LED){
   matrix[snake[i]/8] |= puissance(2,(snake[i] % 8));
   i++;
  }
  matrix[apple/8] |= puissance(2,(apple % 8));
}


