/* Projet Matrice de LED 3D
  Matthias De Bie - Pierre-Jean Petitprez
  IMA4 2013
  Jeu du Snake version 2D
  Pour le branchement des broches de la matrice :
  voir Affuchage.h
  */


#include <Wire.h>
#include <MsTimer2.h>
#include <Arduino.h>
#include "Affichage.h"
#include "Nunchuck.h"
#include "Snake.h"

//Declarations variables pour le nunchuck
const byte DEADZONEX = 30;
const byte DEADZONEY = 20;
const byte DEADZONEZ = 10;
const byte DEADZONEJOYX = 30;
const byte DEADZONEJOYY = 30;
byte cpt,choix=4;
byte data_nunchuck[6];
int accelX,accelY,accelZ,accelXCentre,accelYCentre,accelZCentre;
int joyX,joyY,joyXCentre,joyYCentre;
byte boutonZ,boutonC;

//Declarations variables pour l'affichage
const byte NB_X_MAX = 8;
const byte NB_Y_MAX = 8;
const byte NB_Z_MAX = 8;
const int NB_LED = 64;
const byte NB_OCTETS = NB_LED/8;
byte matrix[NB_OCTETS];


//Declarations variables pour le snake
const byte numX = 8;
const byte numY = 8;
const byte numZ = 8;
byte direc; //direction du snake
int snake[NB_LED];
byte startpoint = 10;
int snakehead = 0;
int snakesize = 1;
int eat = 0;
int apple = 0;
byte collision = 0;
int SnakeSpeed = 400;
unsigned long lastMillis = 0;


/**********************************/

void interrup_aff_byte(){
  affichage_envoi_byte();
}

   
void setup() {
  setup_affichage();
  nunchuck_init();
  MsTimer2::set(20, interrup_aff_byte);
  MsTimer2::start();

  SnakeNewGame(); 
}

void loop() {
  // recuperation des donnees du nunchuck
  nunchuck_read_data();
  
  // si bouton Z enfoncé : recalibrage du nunchuck
  nunchuck_reinit_Z();
  
  //calcul de la nouvelle direction du snake
  SnakeNewDirectionJoystick();  
  
  //avancee du snake
  Snake();
  
  delay(80);

}

